unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBClient, StdCtrls, SMIBase, SMI2OLE;

type
  TForm1 = class(TForm)
    btnImport: TButton;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    lbMDBFile: TLabel;
    edMDBFile: TEdit;
    btnMDBFile: TButton;
    lblTableName: TLabel;
    cbTableName: TComboBox;
    SMImportFromAccess: TSMImportFromAccess;
    OpenDialog1: TOpenDialog;
    procedure btnImportClick(Sender: TObject);
    procedure SMImportFromADOCreateStructure(Sender: TObject;
      Columns: TSMIColumns);
    procedure btnMDBFileClick(Sender: TObject);
    procedure edMDBFileChange(Sender: TObject);
    procedure cbTableNameChange(Sender: TObject);
    procedure cbTableNameDropDown(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnImportClick(Sender: TObject);
begin
  SMImportFromAccess.SourceFileName := edMDBFile.Text;
  SMImportFromAccess.TableName := cbTableName.Text;

  {start an import process}
  SMImportFromAccess.Execute;
end;

procedure TForm1.SMImportFromADOCreateStructure(Sender: TObject;
  Columns: TSMIColumns);
var
  i: Integer;
begin
  {delete all current dataset fields}
  ClientDataSet1.Close;
  ClientDataSet1.FieldDefs.Clear;

  {create a structure by parsed columns from ADO table}
  for i := 0 to Columns.Count-1 do
  begin
    if Columns[i].Size = 0 then
      Columns[i].Size := 30;

    if (Columns[i].FieldName = '') then
      Columns[i].FieldName := 'Field' + IntToStr(i);

    case Columns[i].DataType of
      itString: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftString, Columns[i].Size, False);
      itInteger: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftInteger, 0, False);
      itFloat: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftFloat, 0, False);
      itDateTime: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftDateTime, 0, False);
      itDate: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftDate, 0, False);
      itTime: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftTime, 0, False);
      itBoolean: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftBoolean, 0, False);
    else
      ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftString, 10, False);
    end;
  end;
  ClientDataSet1.CreateDataset;

  {open a dataset with created fields (from table)}
  ClientDataSet1.Active := True;
  ClientDataSet1.LogChanges := False;

  {fill default correspondence between fields in dataset and columns in MS Access}
  SMImportFromAccess.Mappings.Clear;
  SMImportFromAccess.Columns2Mapping;
end;

procedure TForm1.btnMDBFileClick(Sender: TObject);
begin
  OpenDialog1.FileName := edMDBFile.Text;
  if OpenDialog1.Execute then
  begin
    edMDBFile.Text := OpenDialog1.FileName;

    {clear the table list}
    cbTableName.Items.Clear;
  end
end;

procedure TForm1.edMDBFileChange(Sender: TObject);
begin
  {clear the table list}
  cbTableName.Items.Clear;

  {enable the Import button}
  btnImport.Enabled := (edMDBFile.Text <> '') and (cbTableName.Text <> '')
end;

procedure TForm1.cbTableNameChange(Sender: TObject);
begin
  {enable the Import button}
  btnImport.Enabled := (edMDBFile.Text <> '') and (cbTableName.Text <> '')
end;

procedure TForm1.cbTableNameDropDown(Sender: TObject);
begin
  {load the table list}
  if cbTableName.Items.Count = 0 then
    GetAccessTables(cbTableName.Items, edMDBFile.Text, '', '');
end;

end.
