unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, ADODB, SMIBase, SMI2TXT;

type
  TfrmMain = class(TForm)
    ADOConnection1: TADOConnection;
    DataSource1: TDataSource;
    ADOTable1: TADOTable;
    DBGrid1: TDBGrid;
    btnImport: TButton;
    SMImportFromText1: TSMImportFromText;
    procedure FormCreate(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  ADOConnection1.Connected := True;
  ADOTable1.Open;
end;

procedure TfrmMain.btnImportClick(Sender: TObject);
begin
  {file name with text data}
  SMImportFromText1.SourceFileName := ExtractFilePath(Application.ExeName) + 'country.csv';

  {settings for text file}
  SMImportFromText1.FieldDelimiter := fdSemicolon;
  SMImportFromText1.TextQualifier := tqNone;
  SMImportFromText1.RecordSeparator := rsCRLF;

  {correspondence between field names in MS Access and columns in text file}
  SMImportFromText1.Mappings.Clear;
  SMImportFromText1.Mappings.Add('Name=Field1');
  SMImportFromText1.Mappings.Add('Capital=Field2');
  SMImportFromText1.Mappings.Add('Continent=Field3');
  SMImportFromText1.Mappings.Add('Area=Field4');
  SMImportFromText1.Mappings.Add('Population=Field5');

  {import mode: to update existing records and add newest}
  SMImportFromText1.Mode := imAppendUpdate;
  SMImportFromText1.DatasetKeys := 'Name';

  {start an import process}
  SMImportFromText1.Execute;
end;

end.
