unit Main;

interface

{$IFDEF VER140}
  {$DEFINE SMForDelphi6}
{$ENDIF}

{$IFDEF VER150}
  {$DEFINE SMForDelphi6}
  {$DEFINE SMForDelphi7}
{$ENDIF}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, ComCtrls, SMIBase, SMI2TXT,
  ExtCtrls {$IFDEF SMForDelphi6} , Variants {$ENDIF};

type
  TfrmMain = class(TForm)
    dSrc: TDataSource;
    tbl: TTable;
    PageControl: TPageControl;
    tsCountries: TTabSheet;
    DBGrid: TDBGrid;
    pnlTop: TPanel;
    btnImport: TButton;
    tsGeneratedSQL: TTabSheet;
    rtfGeneratedSQL: TRichEdit;
    btnAbout: TButton;
    SMImportFromText1: TSMImportFromText;
    procedure btnImportClick(Sender: TObject);
    procedure SMIWizardDlgBeforeExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure SMImportFromText1AfterRecordEvent(Sender: TObject;
      var Abort: Boolean);
    procedure SMImportFromText1CreateStructure(Sender: TObject;
      Columns: TSMIColumns);
    procedure SMImportFromText1AfterExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
{$R winxp.res}

procedure TfrmMain.btnImportClick(Sender: TObject);
begin
  SMImportFromText1.SourceFileName := ExtractFilePath(Application.ExeName) + 'country.csv';

  {custom delimiters}
  SMImportFromText1.FieldDelimiter := fdSemicolon;
  SMImportFromText1.TextQualifier := tqQuot;

  {NEW:
   generate SQL for update only without real insert/update in dataset}
  SMImportFromText1.ActionKind := akGenerateSQL;

  {skip first row with field names}
  SMImportFromText1.RowFirst := 2;

  {start load process}
  SMImportFromText1.Mode := imAppendUpdate;
  SMImportFromText1.DatasetKeys := 'Name';
  SMImportFromText1.Execute
end;

procedure TfrmMain.SMIWizardDlgBeforeExecute(Sender: TObject);
begin
  rtfGeneratedSQL.Lines.Clear;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  tbl.DatabaseName := ExtractFilePath(Application.ExeName);
  tbl.Open;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  tbl.Close;
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  SMImportFromText1.AboutSMI
end;

procedure TfrmMain.SMImportFromText1AfterRecordEvent(Sender: TObject;
  var Abort: Boolean);
begin
  rtfGeneratedSQL.Lines.Add(SMImportFromText1.Statistic.LastGeneratedSQL + ';')
end;

procedure TfrmMain.SMImportFromText1CreateStructure(Sender: TObject;
  Columns: TSMIColumns);
begin
  {default automatical mappings}
  SMImportFromText1.Columns2Mapping
end;

procedure TfrmMain.SMImportFromText1AfterExecute(Sender: TObject);
begin
  PageControl.ActivePage := tsGeneratedSQL
end;

end.
